#ifndef __SHADERENV_H
#define __SHADERENV_H


////////////
//-- ssao + gi parameters

//#define NUM_SAMPLES 8
#define NUM_SAMPLES 16
//#define NUM_SAMPLES 24
//#define NUM_SAMPLES 96

#define DISTANCE_SCALE 1e-2f

//#define ILLUM_INTENSITY 8e-2f
#define ILLUM_INTENSITY 5e-3f
/// scale factor that takes angle of sample normal into account 
#define VIEW_CORRECTION_SCALE 1.0f

#define NUM_SSAO_FILTER_SAMPLES 16

#define SSAO_FILTER_WIDTH 12.0f
//#define SSAO_FILTER_WIDTH 6.0f

#define SSAO_CONVERGENCE_THRESHOLD 700.0f


////////
//-- reprojection

#define MIN_DEPTH_DIFF 5e-3f
#define PRECISION_SCALE 1e-1f


/////////
//-- shadowing

#define NUM_PCF_TABS 16


//////////
//-- Tone mapping

#define MINLOGLUM (-10.0f)
#define MAXLOGLUM 10.0f

#define INV_LOGLUM_RANGE 0.05f
#define LOGLUM_RANGE 20.0f

#define MAX_LOD_LEVEL 10
/// burnout (really bright regions will be saturated to white)
#define WHITE_LUMINANCE 3e4f


///////////////////

#define NUM_DOWNSAMPLES 9

#define DYNAMIC_OBJECTS_THRESHOLD 1e-8f


#endif // __SHADERENV_H